/**
 * (c) Atos IT Solutions and Services GmbH, 2011.
 * Licensed under EUPL 1.1
 */
package com.sag.osami.context.contexteventtoosgievent;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;
import org.osgi.service.event.EventAdmin;
import org.osgi.service.log.LogService;

import com.sag.osami.api.context.ContextEvent;
import com.sag.osami.api.context.IContextHandler;
import com.sag.osami.api.context.IContextStore;
import com.sag.osami.api.context.OsgiContextEvent;

public class ContextEventToOsgiEvent implements BundleActivator, IContextHandler {

	private IContextStore contextStore;
	private EventAdmin eventAdmin;
	private LogService log;

	@Override
	public void setContextStore(IContextStore contextStore) {
		this.contextStore = contextStore;
		this.log.log(LogService.LOG_INFO, "[ContextEventToOsgiEvent] Set ContextStore", null);

	}

	@Override
	public void start(BundleContext bundleContext) throws Exception {

		this.log = (LogService) bundleContext.getService(bundleContext.getServiceReference(LogService.class.getName()));

		ServiceReference ref = bundleContext.getServiceReference(EventAdmin.class.getName());
		eventAdmin = (EventAdmin) bundleContext.getService(ref);

		this.log.log(LogService.LOG_INFO, "[ContextEventToOsgiEvent] Service started", null);
		bundleContext.registerService(IContextHandler.class.getName(), this, null);
		this.log.log(LogService.LOG_INFO, "[ContextEventToOsgiEvent] Service registered", null);

	}

	@Override
	public void stop(BundleContext arg0) throws Exception {
		// TODO Auto-generated method stub

	}

	@Override
	public void handleContextEvent(ContextEvent context) {
		OsgiContextEvent event = new OsgiContextEvent(context.getType(), null, context);
		eventAdmin.sendEvent(event);
		this.log.log(LogService.LOG_INFO, "[ContextEventToOsgiEvent] New OSGI Event generated", null);

	}

	@Override
	public String[] getDefaultContextTypes() {
		// TODO Auto-generated method stub
		return null;
	}

}
