/**
 * (c) Atos IT Solutions and Services GmbH, 2011.
 * Licensed under EUPL 1.1
 */
package com.sag.osami.context.producer;

import java.util.Calendar;

import org.osgi.service.log.LogService;

import com.sag.osami.api.context.ContextEvent;
import com.sag.osami.api.context.IContextHandler;
import com.sag.osami.api.context.IContextStore;

/**
 * The Class ContextProducerImpl.
 */
public class ContextProducerImpl implements IContextHandler {

	/** The interval. */
	private int interval = 5000;

	/** The id. */
	private String type = "Temp";

	protected LogService log;

	public ContextProducerImpl(int interval, String type, LogService log) {
		super();
		this.interval = interval;
		this.type = type;
		this.log = log;
	}

	public void setContextStore(IContextStore contextStore) {
		try {
			for (int i = 0; i <= 10; i++) {

				Thread.sleep(interval);
				log.log(LogService.LOG_DEBUG, "sending Context over Service");

				ContextEvent c = new ContextEvent(new String("21"), "COM/SAG/OSAMI/id/Temp1", Calendar.getInstance().getTime(), type);

				contextStore.newContextEvent(c);
			}

		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}

	public void handleContextEvent(ContextEvent context) {
		// TODO Auto-generated method stub

	}

	public String[] getDefaultContextTypes() {
		// TODO Auto-generated method stub
		return null;
	}
}
